// масив для расположения шаров - Array, der die Anordnung der Kugeln festhält - Array for the positions of the balls
var massivA = new Array (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
						0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
						0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
						0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

// дополнительный массив для поиска пути и удаления шаров - zusätzlicher Array, der der Wegfindung und der Entfernung von Kugeln dient - Array for pathfinding and deleting balls
var massivB = new Array (0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
						0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
						0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,
						0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0);

// переменная отвечающая за то,что выбран шар или нет для его дальнейшего перемещения - Variable, die festhält, ob eine Kugel gewählt wurde oder nicht, damit diese beim zweiten Klick bewegt werden kann - Variable containing the click of a ball for moving it at next click
var BALLClick = false;

// количество шаров на поле - Die Zahl der Kugeln auf dem Spielfeld - number of balls in the field
var KolvoStep = 0;

// переменные временного хранения параметров шара - Variablen für die temporäre Speicherung der Kugel-Parameter - variable containing the parameters of the ball
var TempX = 0;
var TempY = 0;
var TempZ = 0;
var NextBalls = new Array();

var Delete = false;

// количество очков - Punktzahl - points
var Dollar = 0;

window.onload=init;

function init()
{
	RandomBall(5);
}

function NewGameForSer()
{
	// новая игра - Neues Spiel - new game

	Dollar = 0;
	KolvoStep = 0;
	BALLClick = false;

	for (var x = 0; x<= 8; x++)
		for (var y = 0; y<= 8; y++)
		{
			massivA[ 9 * y + x] = 0;
			massivB[ 9 * y + x] = 0;
			document.getElementById('k'+ (9 * y + x + 1)).src='Lines/7.png';
		}

	RandomBall(5);
}




// Функция для обработки передвижения шаров - Funktion, die die Kugeln versetzt - function for moving the balls
function Move(i,j)
{
	if (massivA[ 9 * j + i]>0)
	{
	//очистка массива для последующего поиска пути - der Array, der der Suche nach einem Weg dient, wird "gereinigt" - the pathfinding array will be cleaned up
		for (var x = 0; x<= 8; x++)
			for (var y = 0; y<= 8; y++)
				massivB[ 9 * y + x] = 0;
		if(TempX > 0 || TempY > 0)
		{
			document.getElementById('k'+ (9 * TempY + TempX + 1)).style.border = 'none';
			document.getElementById('k'+ (9 * TempY + TempX + 1)).style.width = '32px';
			document.getElementById('k'+ (9 * TempY + TempX + 1)).style.height = '32px';
		}
		TempX=i;
		TempY=j;
		document.getElementById('k'+ (9 * TempY + TempX + 1)).style.border = '1px solid #fff';
		document.getElementById('k'+ (9 * TempY + TempX + 1)).style.width = '30px';
		document.getElementById('k'+ (9 * TempY + TempX + 1)).style.height = '30px';
		TempZ=massivA[ 9 * j + i];
		BALLClick=true;
		FindZero(i,j);
	}

	if ((massivA[9 * j + i]==0) && (BALLClick==true) && (massivB[ 9 * j + i ]==1))
	{
		document.getElementById('k'+ (9 * TempY + TempX + 1)).src='Lines/7.png';
		document.getElementById('k'+ (9 * TempY + TempX + 1)).style.border = 'none';
		document.getElementById('k'+ (9 * TempY + TempX + 1)).style.width = '32px';
		document.getElementById('k'+ (9 * TempY + TempX + 1)).style.height = '32px';
		document.getElementById('k'+ (9 * j + i + 1)).src='Lines/'+TempZ+'.png';
		BALLClick=false;
		massivA[ 9 * TempY + TempX ] = 0;
		massivA[ 9 * j + i ] = TempZ;
		RandomBall(); //добавляем шарики - weitere Kugeln auf dem Feld verteilen - scatter more balls into the gamefield
	}
}



// Функция для добавления шаров на поле - Funktion, die 3 bzw. 5 zufällig ausgewählte Kugeln auf per Zufall gewählte Plätze im Feld verteilt - function for distributing 3 or 5 balls randomly into the gamefield
function RandomBall(balls)
{
	if(typeof balls == 'undefined')
		balls = 3;
	var x = 0;
	var y = 0;
	var z = 0;
	var NumberBALL = 0;

	DeleteBALLLine();

	if (Delete == false) 
	{
		while (NumberBALL < balls)
		{
			x=Math.floor(Math.random()*9);
			y=Math.floor(Math.random()*9);

			if (massivA[ 9 * y + x ]==0)
			{
				z=(balls==3 && NextBalls.length > 0) ? NextBalls[NumberBALL] : Math.floor(Math.random()*6+1);
				document.getElementById('k'+ (9 * y + x + 1)).src='Lines/'+z+'.png';
				massivA[ 9 * y + x] = z;
				NextBalls[NumberBALL] = Math.floor(Math.random()*6+1);
				if(NumberBALL < 3)
					document.getElementById('nb'+ NumberBALL).src='Lines/'+NextBalls[NumberBALL]+'.png';
				NumberBALL++;
				KolvoStep++;
			}
			if (KolvoStep==81) break;
		}
		DeleteBALLLine();
	}

	if (KolvoStep==81)
	{
		alert('Game over!');
		//NewGameForSer();
	}
}



// Функция для удаления шаров - Funktion, die mindestens fünf gleichfarbige Kugeln in zusammenhängender Linie entfernt - function for deleting 5 or more one-colored balls in a line
function DeleteBALLLine()
{
	var i = 0;
	var j = 0;

	Delete = false;

	//метка шаров к удалению - von der gesetzten Kugel aus werden die verschiedenen möglichen Richtungen untersucht - investigate lines

	//по горизонталям - die horizontale Linie - horizontal
	for ( i = 0; i<= 4; i++)
		for ( j = 0; j<= 8; j++)
			if ((massivA[ 9 * j + i ] == massivA[ 9 * j + i + 1]) && (massivA[ 9 * j + i ] == massivA[ 9 * j + i + 2]) &&
			   (massivA[ 9 * j + i ] == massivA[ 9 * j + i + 3]) && (massivA[ 9 * j + i ] == massivA[ 9 * j + i + 4]) &&
			   (massivA[ 9 * j + i]>0))
				{
					massivB[ 9 * j + i ] = -20;
					massivB[ 9 * j + i + 1 ] = -20;
					massivB[ 9 * j + i + 2 ] = -20;
					massivB[ 9 * j + i + 3 ] = -20;
					massivB[ 9 * j + i + 4 ] = -20;
				}

	//по вертикалям - die vertikale - vertikal
	for ( i = 0; i<= 8; i++)
		for ( j = 0; j<= 4; j++)
			if ((massivA[ 9 * j + i ] == massivA[ 9 * j + i + 9 ]) && (massivA[ 9 * j + i ] == massivA[ 9 * j + i + 18 ]) &&
			   (massivA[ 9 * j + i ] == massivA[ 9 * j + i + 27 ]) && (massivA[ 9 * j + i ] == massivA[ 9 * j + i + 36]) &&
			   (massivA[ 9 * j + i]>0))
				{
					massivB[ 9 * j + i ] = -20;
					massivB[ 9 * j + i + 9 ] = -20;
					massivB[ 9 * j + i + 18 ] = -20;
					massivB[ 9 * j + i + 27 ] = -20;
					massivB[ 9 * j + i + 36 ] = -20;
				}

	//по диагоналям - und die diagonale - diagonal
	for ( i = 0; i<= 4; i++)
		for ( j = 0; j<= 4; j++)
			if ((massivA[ 9 * j + i ] == massivA[ 9 * j + i + 10 ]) && (massivA[ 9 * j + i ] == massivA[ 9 * j + i + 20 ]) &&
			   (massivA[ 9 * j + i ] == massivA[ 9 * j + i + 30 ]) && (massivA[ 9 * j + i ] == massivA[ 9 * j + i + 40]) &&
			   (massivA[ 9 * j + i]>0))
				{
					massivB[ 9 * j + i ] = -20;
					massivB[ 9 * j + i + 10 ] = -20;
					massivB[ 9 * j + i + 20 ] = -20;
					massivB[ 9 * j + i + 30 ] = -20;
					massivB[ 9 * j + i + 40 ] = -20;
				}

	for ( i = 8; i>= 4; i-- )
		for ( j = 0; j<= 4; j++)
			if ((massivA[ 9 * j + i ] == massivA[ 9 * j + i + 8 ]) && (massivA[ 9 * j + i ] == massivA[ 9 * j + i + 16 ]) &&
			   (massivA[ 9 * j + i ] == massivA[ 9 * j + i + 24 ]) && (massivA[ 9 * j + i ] == massivA[ 9 * j + i + 32]) &&
			   (massivA[ 9 * j + i]>0))
				{
					massivB[ 9 * j + i ] = -20;
					massivB[ 9 * j + i + 8 ] = -20;
					massivB[ 9 * j + i + 16 ] = -20;
					massivB[ 9 * j + i + 24 ] = -20;
					massivB[ 9 * j + i + 32 ] = -20;
				}

	// удаление - die Kugeln werden entfernt - remove the balls
	for ( i = 0; i<=8; i++)
		for ( j = 0; j<=8; j++)
			if (massivB[ 9 * j + i ] == -20)
			{
				document.getElementById('k'+ (9 * j + i + 1)).src='Lines/7.png';
				Delete = true;
				KolvoStep--;
				Dollar += 20;
				massivA[ 9 * j + i ] = 0;
				massivB[ 9 * j + i ] = 0;
			}
	document.getElementById('otschki').value = 'Очки: ' + Dollar;
	document.getElementById('scharje').value = 'Шары: '+ KolvoStep;
}


// Функция для поиска возможного пути - Funktion, die prüft, ob es eine freie Verbindung zwischen zwei Feldern gibt - function for pathfinding
function FindZero(x1,y1)
{
	for (var Colonka = x1 - 1; Colonka <= x1+1; Colonka++)
		for (var Stolbik = y1-1; Stolbik <= y1+1; Stolbik++)
		{

			if ((Colonka >= 0) && (Colonka <9) && (Stolbik >= 0) && (Stolbik < 9) && (massivB[9 * Stolbik + Colonka]==0) && (massivA[9 * Stolbik + Colonka]==0))
			{

			   if ((Colonka==x1 -1) && (Stolbik==y1-1)) continue;
			   if ((Colonka==x1+1) && (Stolbik==y1-1)) continue;
			   if ((Colonka==x1+1) && (Stolbik==y1+1)) continue;
			   if ((Colonka==x1 -1) && (Stolbik==y1+1)) continue;

				massivB[9 * Stolbik + Colonka]=1;
				FindZero(Colonka, Stolbik);
			}
		}
}